"{ Encoding: utf8 }"

"{ Package: 'stx:libcompat' }"

"{ NameSpace: Dolphin }"

Collection subclass:#SharedSet
	instanceVariableNames:'mutex set'
	classVariableNames:''
	poolDictionaries:''
	category:'Compatibility-Dolphin'
!


!SharedSet class methodsFor:'instance creation'!

new
    ^ self basicNew initialize
! !

!SharedSet methodsFor:'adding & removing'!

add:anObject
    |rslt|

    mutex critical:[
        rslt := set add:anObject
    ].
    ^ rslt.
!

remove:anElement ifAbsent:exceptionBlock
    |rslt|

    mutex critical:[
        rslt := set remove:anElement ifAbsent:exceptionBlock
    ].
    ^ rslt.

    "Created: / 23-09-2011 / 21:16:59 / cg"
! !

!SharedSet methodsFor:'enumeration'!

do:aBlock
    mutex critical:[
        set do:aBlock
    ].
! !

!SharedSet methodsFor:'queries'!

includes:anObject
    |rslt|

    mutex critical:[
        rslt := set includes:anObject
    ].
    ^ rslt.
!

isFixedSize
    "return true if the receiver cannot grow"

    ^ false
!

size
    ^ set size.
! !

!SharedSet methodsFor:'setup'!

initialize
    mutex := Semaphore forMutualExclusion.
    self initializeSet.

    "Modified: / 23-09-2011 / 13:36:10 / cg"
!

initializeSet
    set := Set new.

    "Created: / 23-09-2011 / 13:36:05 / cg"
! !

!SharedSet class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^ '$Id$'
! !

